// mit gcc  glei414 August 2000 
/*
 Kompilieren:

gcc glei414.cpp  -o glei414 -lm  -static

In windows: geht nicht !!!
If you are using MinGW, the problem is that by default, MinGW uses the I/O resp. 
formatting functions from the Microsoft C runtime, 
which doesn't support 80 bit floating point numbers (long double == double in Microsoft land).
gcc -Wformat glei414.cpp -o glei414.exe -D__USE_MINGW_ANSI_STDIO -lm -static
*/
/*
   alles mit long double
   mit Rueckrechnung
   nach Pascalprogramm angeglichen
   getestete Gleichungen:

   richtig:
   4     3     6     7     8   =  0
   88   99   -77    88   -99
   1     0     0     0     1
   1    -3     6   -12     8
   1   -10    35   -50    24
   1    -2     2    -2     1
   1     0   -13     0    36
   1    -4     8    -8     4
   1     8    24    32    16
   1     2   -13   -14    24
  -2    -4    26    28   -48
   1     0     5     0     4
   1    -8    24   -32    16

   1   -11    42   -64    32
   1    -9    29   -39    18
   1    -1     0     0    0

*/

#include <stdio.h>
#include <math.h>

#define EPS 1.0e-12                                  /* fuer Nullvergleich */
#define reps 1.0e-6                                  // fuer Rueckrechnung
// --------------------- Variablen ----------------------------------------

long double an,bn,cn,dn,en;                        /* Eingabekoeffizienten */
long double a,b,c,d;              /* Koeffizienen der normierten Gleichung */
				  /* Koeff von x^4 ist 1                   */
long double b1,c1,d1;           /* Koeffizienten der reduzierten Gleichung */
				/* vierten Grades                          */

long double p1re,p1im,p2re,p2im,p3re,p3im;
long double x1re,x1im,x2re,x2im,x3re,x3im,x4re,x4im;
long double x1rered,x2rered,x3rered,x4rered;
long double x1imred,x2imred,x3imred,x4imred;
long double t1re,t1im,t2re,t2im,t3re,t3im;

// --------------------------------------------- fuer Rueckrechnuhng
struct komplex                                // Record fr Komplexe Zahlen
 {
   long double re;
   long double im;
 }x1,x2,x3,x4,A,B,C,D,H1,H2,H3,H4,H5,H6;      // x1,x2,x3,x4 Loesungen
					      // A,B,C,D Koeffizienten
					      // H1,H2,H3,H4 Hilfsvariablen
long double ran,rbn,rcn,rdn,ren;           // rueckgerechnete Koeffizienten



/* --------------------- Prototypen der Unterprogramme ------------------ */
int sgn(long double x);
long double arccos(long double x);
void gleichungsausgabe();
void standardform();
void reduktion();
void resolvent();
void P6Gleichung();
void kombination();
void comsqrt2(long double a,long double b,long double *pu,long double *pv);
void ausgabe();
void eingabe();

void rueckeingabe(void);
void rueck4();
struct komplex kadd( struct komplex &z1, struct komplex &z2);
struct komplex kmult( struct komplex &z1, struct komplex &z2);
struct komplex kneg( struct komplex &z);
void rueckausgabe1( struct komplex &A, struct komplex &B, struct komplex &C,
	      struct komplex &D);
void rueckausgabe2( struct komplex &A, struct komplex &B, struct komplex &C,
	      struct komplex &D, long double an);
void ausgangsgleichung();


/* --------------------- Hauptprogramm ---------------------------------- */
int main()
{
  
  eingabe();
  gleichungsausgabe();
  standardform();
  reduktion();
  resolvent();
  P6Gleichung();
  kombination();
  ausgabe();
  
							     // Rueckrechnung
  rueckeingabe();
  rueck4();
  
  
  rueckausgabe1(A,B,C,D);
  rueckausgabe2(A,B,C,D,an);
  ausgangsgleichung();
  return 0;
}                                                             // end of main

/* ------------------------ Unterprogramme ------------------------------ */
int sgn(long double x)
{
  int vz;
  if(x < -EPS) vz = -1;
  else {
    if (x > EPS) vz = 1;
      else vz = 0;
  };
  return(vz);
};

long double  arccos(long double x)
{
    long double u;
    if (sgn(x) == 0)  return(M_PI/2.0);
    else u = atan(sqrtl(1-x*x)/x) + (1.0 - sgn(x))*(M_PI/2.0);
    return(u);
};


void  gleichungsausgabe()
{
  printf("eingegebene Gleichung vierten Grades=\n");
  printf("    A * X^4   +  B * X^3    +   C * X^2    +   D * X  +   E");
  printf("   =   0 \n\n");
  printf(" %10.5Lf    %10.5Lf   %10.5Lf   %10.5Lf   %10.5Lf ",an,bn,cn,dn,en);
  printf("   =   0\n");
  printf("   ========================================================\n");
}

void standardform()
{
  if (sgn(an) != 0)  {
    a = bn/an;
    b = cn/an;
    c = dn/an;
    d = en/an;
  };
}

void reduktion()
{
  if (sgn(a) == 0){
    b1 = b;
    c1 = c;
    d1 = d;
  }
  else
  b1 = b - (3.0*a*a)/8.0;
  c1 = c - (a*b)/2.0 + (a*a*a)/8.0;
  d1 = d - (a*c)/4.0 + (a*a*b)/16.0 - (3.0*a*a*a*a)/256.0;

  printf("Reduzierte Gleichung  ");
  printf("b1 =  %10.5Lf   c1 = %10.5Lf d1 =  %10.5Lf\n",b1,c1,d1);
  
};

void resolvent()
					/* p^6 + a2*p^4 + b2*p^2 + c2 = 0 */
				        /* t^3 + a2*t^2 + b2*T + c2 = 0   */
{

  long double  a2,b2,c2,
	  pk,qk,disk,
	  u,v,uh,vh,phi,
	  z1re,z1im,z2re,z2im,z3re,z3im;
			// z = Loesung der reduzierten kubischen  Resolvente
			// z^3 + pk*z + qk = 0
			// Loesung der kubischen Resolvente  t = z - a2/3
  int fallres;          // Fallunterscheidung bei der reduzierten kubischen
			// Resolvente
  int usign,vsign;

  a2 = 2.0*b1;
  b2 = b1*b1 - 4*d1;
  c2 = -c1*c1;
  printf("Resolvente  ");
  printf("a2 = %10.5Lf",a2); printf(" b2 = %10.5Lf",b2);
  printf("  c2 =%10.5Lf \n",c2);
  
		       /* Loesung der kubischen Resolvente  t = z - a2/3  */

  pk = -(a2*a2)/3.0 + b2;
						   /* Z^3 + pk*Z + qk = 0 */
  qk = 2.0*(a2*a2*a2)/27.0 - a2*b2/3.0 + c2;
  disk = qk*qk/4.0 + (pk*pk*pk)/27.0;
  fallres= sgn(disk);

  switch(fallres)
     {
				// Fall1= 1 reelle,2 konj.komplexe Loesungen
     case 1:
	uh =   -qk/2.0 + sqrtl(disk);  usign = sgn(uh);
	vh =   -qk/2.0 - sqrtl(disk);  vsign = sgn(vh);
	if (sgn(uh) == 0)
	   u = 0.0;
	else u = exp((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	   v = 0.0;
	else v = exp((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = u + v; z1im = 0.0;
	z2re = -(u + v)/2.0; z2im = (u - v)/2.0 * sqrtl(3.0);
	z3re = z2re; z3im = -z2im;
	break;

     case 0:                         /* 1 reelle, 1 reelle Doppelloesung */
	uh = -qk/2.0; usign = sgn(uh);
	vh = -qk/2.0; vsign = sgn(vh);
	if (sgn(uh) == 0)
	   u = 0.0;
	else u = exp((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	  v = 0.0;
	else v = exp((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = 2*u; z1im = 0.0;
	z2re = -u; z2im = 0.0;
	z3re = z2re; z3im = z2im;
	break;

    case -1:                                /* Fall3= casus irreducibilis */
	uh = -(pk*pk*pk)/27.0;
	printf("Resolvente Casus irreducibilis uh =  ");
	printf("%10.5Lf\n ",uh);
	
	phi = arccos((-qk/2.0)/sqrtl(uh));
	z1re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0);
	z2re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 + (2.0*M_PI/3.0));
	z3re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 - (2.0*M_PI/3.0));
	z1im = 0.0; z2im = 0.0; z3im = 0.0;
	break;
  };
  t1re = z1re - a2/3.0; t1im = z1im;
  t2re = z2re - a2/3.0; t2im = z2im;
  t3re = z3re - a2/3.0; t3im = z3im;

  printf("pk = %10.5Lf   qk  = %10.5Lf",pk,qk);
  printf("  fallres = %4d \n",fallres);
  printf("z1re = %10.5Lf  z1im = %10.5Lf\n",z1re,z1im);
  printf("z2re = %10.5Lf  z2im = %10.5Lf\n",z2re,z2im);
  printf("z3re = %10.5Lf  z3im = %10.5Lf\n",z3re,z3im);

  printf("t1re =  %10.5Lf  t1im =  %10.5Lf\n",t1re,t1im);
  printf("t2re =  %10.5Lf  t2im =  %10.5Lf\n",t2re,t2im);
  printf("t3re =  %10.5Lf  t3im =  %10.5Lf\n",t3re,t3im);
  
};

void P6Gleichung()
{
  comsqrt2(t1re,t1im,&p1re,&p1im);
  comsqrt2(t2re,t2im,&p2re,&p2im);
  comsqrt2(t3re,t3im,&p3re,&p3im);
  printf("p1re  = %10.5Lf   p1im = %10.5Lf\n",p1re,p1im);
  printf("p2re  = %10.5Lf   p2im = %10.5Lf\n",p2re,p2im);
  printf("p3re  = %10.5Lf   p3im = %10.5Lf\n",p3re,p3im);
  printf("Das Vorzeichen von c1 =  %4d\n",sgn(c1));
};

void kombination()
{
  if((sgn(c1) == 0) || (sgn((sgn(t1re)+sgn(t2re)+sgn(t3re)))*sgn(c1) == -1))
  {
    x1re = 0.5 * (p1re + p2re + p3re) - a/4.0;
    x2re = 0.5 * (p1re - p2re - p3re) - a/4.0;
    x3re = 0.5 * (-p1re - p2re + p3re) - a/4.0;
    x4re = 0.5 * (-p1re + p2re - p3re) - a/4.0;

    x1im = 0.5 * (p1im + p2im + p3im);
    x2im = 0.5 * (p1im - p2im - p3im);
    x3im = 0.5 * (-p1im - p2im + p3im);
    x4im = 0.5 * (-p1im + p2im - p3im);
  }
  else
  {
    x1re = 0.5 * (-p1re - p2re - p3re) - a/4.0;
    x2re = 0.5 * (-p1re + p2re + p3re) - a/4.0;
    x3re = 0.5 * (p1re + p2re - p3re) - a/4.0;
    x4re = 0.5 * (p1re - p2re + p3re) - a/4.0;

    x1im = 0.5 * (-p1im - p2im - p3im);
    x2im = 0.5 * (-p1im + p2im + p3im);
    x3im = 0.5 * (p1im + p2im - p3im);
    x4im = 0.5 * (p1im - p2im + p3im);
  }
  printf("Loesungen der reduzierten Gleichung  \n");
    x1rered = x1re + a/4.0; x1imred = x1im ;
    x2rered = x2re + a/4.0; x2imred = x2im ;
    x3rered = x3re + a/4.0; x3imred = x3im ;
    x4rered = x4re + a/4.0; x4imred = x4im ;

    printf("x1rered   = %10.5Lf   x1imred = %10.5Lf\n",x1rered,x1imred);
    printf("x2rered   = %10.5Lf   x2imred = %10.5Lf\n",x2rered,x2imred);
    printf("x3rered   = %10.5Lf   x3imred = %10.5Lf\n",x3rered,x3imred);
    printf("x4rered   = %10.5Lf   x4imred = %10.5Lf\n",x4rered,x4imred);

};

void comsqrt2(long double a,long double b,long double *pu,long double *pv)
{
long double vz;                                 // Vorzeichenkorrekturfaktor
  vz =  1.0 + sgn(b) - sgn(b)*sgn(b);
  *pu = vz*sqrtl(0.5*(a + sqrtl(a*a + b*b)));
  *pv = sqrtl(0.5*(-a + sqrtl(a*a + b*b)));
};

void ausgabe()
{
  printf("Loesungen:\n");
  printf("X1= %10.5Lf  %10.5Lf     \n",x1re,x1im);
  printf("X2= %10.5Lf  %10.5Lf     \n",x2re,x2im);
  printf("X3= %10.5Lf  %10.5Lf     \n",x3re,x3im);
  printf("X4= %10.5Lf  %10.5Lf     \n",x4re,x4im);
};

void eingabe()
{
   printf("Wert von A ? "); scanf("%Lf",&an);
   printf("Wert von B ? "); scanf("%Lf",&bn);
   printf("Wert von C ? "); scanf("%Lf",&cn);
   printf("Wert von D ? "); scanf("%Lf",&dn);
   printf("Wert von E ? "); scanf("%Lf",&en);
};

void rueckeingabe(void)
{
  x1.re = x1re;
  x1.im = x1im;
  x2.re = x2re;
  x2.im = x2im;
  x3.re = x3re;
  x3.im = x3im;
  x4.re = x4re;
  x4.im = x4im;
  printf("\n");
  printf("\n");
  printf("\n");
  printf("Folgende Loesungen werden fuer die Rueckrechnung verwendet:");
  printf("\n");
  printf("Loesung x1:   %+Lf  %+Lf*i\n",x1.re,x1.im);
  printf("Loesung x2:   %+Lf  %+Lf*i\n",x2.re,x2.im);
  printf("Loesung x3:   %+Lf  %+Lf*i\n",x3.re,x3.im);
  printf("Loesung x4:   %+Lf  %+Lf*i\n",x4.re,x4.im);
  printf("\n");
}

void rueck4()
{
  H1 = kadd(x1,x2);                             // Summe von x1 und x2
  H2 = kadd(x3,x4);
  H3 = kadd(H1,H2);
  A = kneg(H3);                                 // negative Summe

  H1 = kmult(x1,x2);
  H2 = kmult(x1,x3);
  H3 = kadd(H1,H2);
  H1 = kmult(x1,x4);
  H2 = kmult(x2,x3);
  H4 = kadd(H1,H2);
  H5 = kadd(H3,H4);
  H1 = kmult(x2,x4);
  H2 = kmult(x3,x4);
  H6 = kadd(H1,H2);
  B = kadd(H5,H6);

  H1 = kmult(x1,x2);
  H2 = kmult(H1,x3);
  H3 = kmult(H1,x4);
  H4 = kadd(H2,H3);
  H1 = kmult(x1,x3);
  H2 = kmult(H1,x4);
  H3 = kmult(x2,x3);
  H5 = kmult(H3,x4);
  H6 = kadd(H2,H5);
  H1 = kadd(H4,H6);
  C = kneg(H1);

  H1 = kmult(x1,x2);
  H2 = kmult(x3,x4);
  D = kmult(H1,H2);
};

struct komplex kadd( struct komplex &z1, struct komplex &z2)
{
  struct komplex z3;
  z3.re = z1.re + z2.re;
  z3.im = z1.im + z2.im;
  return z3;
}


struct komplex kmult( struct komplex &z1, struct komplex &z2)
{
  struct komplex z3;
  z3.re = (z1.re*z2.re) - (z1.im*z2.im);
  z3.im = (z1.re*z2.im) + (z1.im*z2.re);
  return z3;
}


struct komplex kneg( struct komplex &z)
{
  struct komplex z3;
  z3.re = -z.re;
  z3.im = -z.im;
  return z3;
}

void rueckausgabe1( struct komplex &A, struct komplex &B, struct komplex &C,
	      struct komplex &D)
{
  //printf("\n");
  //printf("\n");
  printf("\n");
  if((A.im < reps)  && (B.im < reps) && (C.im < reps) && (D.im < reps))
    {
      printf("\n");
      printf("Die rueckgerechnete normierte Gleichung lautet:\n");
      printf("x^4   %+8.4Lf*x^3   %+8.4Lf*x^2   ",A.re,B.re);
      printf("%+8.4Lf*x   %+8.4Lf   =   0",C.re,D.re);
     } else {
	      printf("\n");
	      printf("Es ergeben sich komplexe Koeffizienten:\n");
	      printf("A = %+8.4Lf      i  %+8.4Lf\n",A.re,A.im);
	      printf("B = %+8.4Lf      i  %+8.4Lf\n",B.re,B.im);
	      printf("C = %+8.4Lf      i  %+8.4Lf\n",C.re,C.im);
	      printf("D = %+8.4Lf      i  %+8.4Lf\n",D.re,D.im);
     }
}

void rueckausgabe2( struct komplex &A, struct komplex &B, struct komplex &C,
	      struct komplex &D, long double an)

{
    ran = an;
    rbn = A.re*an;
    rcn = B.re*an;
    rdn = C.re*an;
    ren = D.re*an;
  if((A.im < reps)  && (B.im < reps) && (C.im < reps) && (D.im < reps))
    {
      //printf("\n");
      //printf("\n");
      //printf("\n");
      printf("\n");
      printf("Die rueckgerechnete Ausgangsgleichung lautet:\n");
      printf("%10.5Lf*x^4   %+10.5Lf*x^3   %+10.5Lf*x^2   ",ran,rbn,rcn);
      printf("%+10.5Lf*x   %+10.5Lf   =   0",rdn,ren);
     }
}

void  ausgangsgleichung()
{
  //printf("\n");
  //printf("\n");
  printf("\n");
  printf("Die urspruenglich eingegebene Gleichung vierten Grades:\n");
  printf("    A * X^4   +  B * X^3    +   C * X^2    +   D * X  +   E");
  printf("   =   0 \n\n");
  printf(" %10.5Lf    %10.5Lf   %10.5Lf   %10.5Lf   %10.5Lf ",an,bn,cn,dn,en);
  printf("   =   0\n");
}

